> For the complete documentation index, see [llms.txt](https://docs.exads.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.exads.com/rtb/publishers/exads-rtb/exads-rtb-publishers-request.md).

# EXADS RTB Bid Request Specifications

{% hint style="info" %}
**Note**: The EXADS RTB Bid Request is done using JSON for POST and a URL for GET.
{% endhint %}

***

## Suggested Bid Request Headers <a href="#suggested-bid-request-headers" id="suggested-bid-request-headers"></a>

* EXADS RTB Version HTTP Header: x-exadsrtb-version: 1.0
* Keep-Alive HTTP Header: Connection: Keep-Alive
* Content JSON: Content-Type: application/json

EXADS allows two HTTP methods for requests: POST and GET.

## Bid Request Object <a href="#bid-request-object" id="bid-request-object"></a>

| Attribute         | Description                                                                                                                     |
| ----------------- | ------------------------------------------------------------------------------------------------------------------------------- |
| id                | Unique bid request ID (string)\*                                                                                                |
| ip                | IP address of the user (string)\*                                                                                               |
| language          | Browser language using ISO-639-1-alpha-2 (string)\*                                                                             |
| remote\_addr      | Main IP address of the user (string)                                                                                            |
| x\_forwarded\_for | X-FORWARDED-FOR IP address of the user or empty if not set (string)                                                             |
| type              | Request type. Can be “banner”, “popunder” or “push\_notification” (string)\*                                                    |
| ua                | Browser user agent (string)\*                                                                                                   |
| url               | Full URL of the page where the ad will be shown (string)\*                                                                      |
| user\_id          | Unique user ID (string)\*                                                                                                       |
| sub               | This should be a number between six and ten digits: Do not use zeroes at the beginning of Sub IDs.                              |
| export            | Response type. Can be "json" or "xml" (string)\*                                                                                |
| keyword           | Keywords can be used to ensure ad zones get the right type of advertising. Keywords should be a string of comma-separated words |
| size              | Publisher ad type size (string)\*\*                                                                                             |
| el                | Base64 Encoded Email (string)\*\*\*                                                                                             |

\* mandatory fields

\*\* mandatory only for **Banner**

\*\*\* available only for **RTB Direct Links** and **RTB Email Clicks**

## Bid Request POST: JSON <a href="#bid-request-post-json" id="bid-request-post-json"></a>

***

**Note**: EXADS RTB POST Bid requests are done using JSON only, so there are no XML examples below.

***

### Banner: JSON <a href="#banner-json" id="banner-json"></a>

```json
{
    "id": "d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa",
    "ip": "131.34.123.159",
    "language": "en",
    "type": "banner",
    "remote_addr": "131.34.123.159",
    "x_forwarded_for": "",
    "ua": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36",
    "url": "https://sitedomain.com/page",
    "user_id": "57592f333f8983.043587162282415065",
    "sub": 1234,
    "export": "json",
    "keyword": "lifestyle, humor",
    "size": "300x250"
}
```

### Popunder: JSON <a href="#popunder-json" id="popunder-json"></a>

```json
{
    "id": "d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa",
    "ip": "131.34.123.159",
    "language": "en",
    "type": "popunder",
    "remote_addr": "131.34.123.159",
    "x_forwarded_for": "120.52.73.97",
    "ua": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36",
    "url": "https://sitedomain.com/page",
    "user_id": "57592f333f8983.043587162282415065",
    "sub": 4312,
    "export": "json",
    "keyword": "lifestyle, humor"
}
```

### Push Notifications - 720 x 480: JSON <a href="#push-notifications---720-x-480-json" id="push-notifications---720-x-480-json"></a>

```json
{
    "id": "d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa",
    "ip": "131.34.123.159",
    "language": "en",
    "type": "push_notification",
    "remote_addr": "131.34.123.159",
    "x_forwarded_for": "120.52.73.97",
    "ua": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36",
    "url": "https://sitedomain.com/page",
    "user_id": "57592f333f8983.043587162282415065",
    "sub": 4312,
    "export": "json",
    "keyword": "lifestyle, humor",
    "size": "720x480"
}
```

### Push Notifications 192 x 192: JSON <a href="#push-notifications-192-x-192-json" id="push-notifications-192-x-192-json"></a>

Here size parameter may be omitted. It will just be assumed as 192x192 by default for backwards compatibility.

```json
{
    "id": "d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa",
    "ip": "131.34.123.159",
    "language": "en",
    "type": "push_notification",
    "remote_addr": "131.34.123.159",
    "x_forwarded_for": "120.52.73.97",
    "ua": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36",
    "url": "https://sitedomain.com/page",
    "user_id": "57592f333f8983.043587162282415065",
    "sub": 4312,
    "export": "json",
    "keyword": "lifestyle, humor",
    "size": "192x192"
}
```

### In-Page Push Notifications: JSON <a href="#in-page-push-notifications-json" id="in-page-push-notifications-json"></a>

```json
{
    "id": "5c2e180f3a1371d9256f6616c6792fb2c7a64772",
    "ip": "131.34.123.159",
    "language": "en",
    "type": "in_page_push_notification",
    "remote_addr": "131.34.123.159",
    "x_forwarded_for": "120.52.73.97",
    "ua": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36",
    "url": "https://sitedomain.com/page",
    "user_id": "57592f333f8983.043587162282415065",
    "sub": 1234,
    "export": "json",
    "keyword": "Adult"
}
```

### Direct Link: JSON <a href="#direct-link-json" id="direct-link-json"></a>

```json
{
    "id": "d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa",
    "ip": "131.34.123.159",
    "language": "en",
    "type": "direct_link",
    "remote_addr": "131.34.123.159",
    "x_forwarded_for": "120.52.73.97",
    "ua": "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36",
    "url": "https://sitedomain.com/page",
    "user_id": "57592f333f8983.043587162282415065",
    "sub": 4312,
    "export": "json",
    "keyword": "lifestyle, humor",
    "el": "dGVzdEBleGFkcy5jb20="
}
```

## Bid request GET: URL <a href="#bid-request-get-url" id="bid-request-get-url"></a>

### Banner: URL <a href="#banner-url" id="banner-url"></a>

```
https://rtb.{examplenetworkdomain}/rtb.php?idzone=2999625&fid=bc64cd7206ae2b2d4346f73629595660d3d117ac&id=d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa&ip=131.34.123.159&language=en&type=banner&remote_addr=131.34.123.159&ua=Mozilla/5.0%20(X11;%20Linux%20x86_64)%20AppleWebKit/537.36%20(KHTML,%20like%20Gecko)%20Chrome/66.0.3359.139%20Safari/537.36&url=https://sitedomain.com/page&user_id=57592f333f8983.043587162282415065&sub=1234&export=json&keyword=lifestyle,humour&size=300x250
```

### Email Clicks: URL <a href="#email-clicks-url" id="email-clicks-url"></a>

```
https://rtb.{networkdomain}/rtb.php?idzone=2999625&fid=bc64cd7206ae2b2d4346f73629595660d3d117ac&id=d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa&type=email_click&keyword=lifestyle,humour&export=xml&ip=192.168.1.70&ua=Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36&user_id=1&el=dGVzdGVAZW1haWwuY29t
```

### Popunder: URL <a href="#popunder-url" id="popunder-url"></a>

```
https://rtb.{examplenetworkdomain}/rtb.php?idzone=2999625&fid=bc64cd7206ae2b2d4346f73629595660d3d117ac&id=d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa&ip=131.34.123.159&language=en&type=popunder&remote_addr=131.34.123.159&x_forwarded_for=120.52.73.97&ua=Mozilla/5.0%20(X11;%20Linux%20x86_64)%20AppleWebKit/537.36%20(KHTML,%20like%20Gecko)%20Chrome/66.0.3359.139%20Safari/537.36&url=https://sitedomain.com/page&user_id=57592f333f8983.043587162282415065&sub=4312&export=json&keyword=lifestyle,humour
```

### Push Notifications 720 x 480: URL <a href="#push-notifications-720-x-480-url" id="push-notifications-720-x-480-url"></a>

```
https://rtb.{examplenetworkdomain}/rtb.php?idzone=2999625&fid=bc64cd7206ae2b2d4346f73629595660d3d117ac&id=d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa&ip=131.34.123.159&language=en&type=push_notification&remote_addr=131.34.123.159&x_forwarded_for=120.52.73.97&ua=Mozilla/5.0%20(X11;%20Linux%20x86_64)%20AppleWebKit/537.36%20(KHTML,%20like%20Gecko)%20Chrome/66.0.3359.139%20Safari/537.36&url=https://sitedomain.com/page&user_id=57592f333f8983.043587162282415065&sub=4312&export=json&keyword=lifestyle,humour&size=720x480
```

### Push Notifications 192 x 192: URL <a href="#push-notifications-192-x-192-url" id="push-notifications-192-x-192-url"></a>

Here the size parameter may be omitted. It will just be assumed as 192x192 by default for backwards compatibility.

```
https://rtb.{examplenetworkdomain}/rtb.php?idzone=2999625&fid=bc64cd7206ae2b2d4346f73629595660d3d117ac&id=d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa&ip=131.34.123.159&language=en&type=push_notification&remote_addr=131.34.123.159&x_forwarded_for=120.52.73.97&ua=Mozilla/5.0%20(X11;%20Linux%20x86_64)%20AppleWebKit/537.36%20(KHTML,%20like%20Gecko)%20Chrome/66.0.3359.139%20Safari/537.36&url=https://sitedomain.com/page&user_id=57592f333f8983.043587162282415065&sub=4312&export=json&keyword=lifestyle,humour&size=192x192
```

### In-Page Push Notifications: URL <a href="#in-page-push-notifications-url" id="in-page-push-notifications-url"></a>

```
http://rtb.{examplenetworkdomain}/rtb.php?idzone=5307609&fid=bd1110cd7802712c5f7abb146954fb89748c236b&id=d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa&ip=131.34.123.159&language=en&type=in_page_push_notification&remote_addr=131.34.123.159&x_forwarded_for=120.52.73.97&ua=Mozilla/5.0%20(X11;%20Linux%20x86_64)%20AppleWebKit/537.36%20(KHTML,%20like%20Gecko)%20Chrome/66.0.3359.139%20Safari/537.36&url=https://sitedomain.com/page&user_id=57592f333f8983.043587162282415065&sub=4312&export=json&keyword=lifestyle,humour&size=192x192
```

### Direct Link: URL <a href="#direct-link-url" id="direct-link-url"></a>

```
http://rtb.{examplenetworkdomain}/rtb.php?idzone=3206099&fid=326d931254f7552d8f3b80cf34e9e09a2924867c&ua=Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36&ip=131.34.123.159&id=d4b5c697-41f3-4c1c-a3d5-5fd01b5ef2aa&type=direct_link&keyword=lifestyle,humour&export=xml&el=dGVzdGVAZW1haWwuY29t
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.exads.com/rtb/publishers/exads-rtb/exads-rtb-publishers-request.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
